openapi: 3.0.3
info:
  title: Smart Road Traffic Flow Monitoring Data Models
  description: |-
    Model Definitions for a Road Traffic Flow Monitoring System.
  version: 0.0.1

components:
  schemas:
    TrafficFlowObserved:
      allOf:
        - $ref: "https://gitlab.com/api/v4/projects/41833409/repository/files/baseline%2Eyaml/raw?master=main#/components/schemas/TrafficFlowObserved"
        - type: object
          properties:
            levelOfService:
              description: |
                'Level of Service - a qualitative measure used to relate the quality of motor vehicle traffic service. It's calculated based on speed and occupancy. The speed and occupancy thresholds that determine these service levels vary depending on the measurement point.'
              enum:
                - FluidTraffic
                - SlowTraffic
                - Retentions
                - Congestion
              type: string
              x-ngsi:
                type: Property
            roadLoad:
              description: 'It represents an estimate of the degree of congestion, calculated from an algorithm that uses intensity and occupancy as variable, with certain correction factors. Sets the degree of use of the road in a range from 0% (empty) to 100% (collapsed).'
              minimum: 0
              maximum: 100
              type: number
              x-ngsi:
                model: https://schema.org/Number.
                type: Property
            saturationFlow:
              description: 'Total number of vehicles in conditions of traffic flow saturation.'
              type: number
              x-ngsi:
                model: https://schema.org/Number.
                type: Property


# These paths are merely representative.
paths: 
  /ngsi-ld/v1/entities: 
    get: 
      responses: 
        ? "200"
        : 
          description:  OK
          content: 
            application/ld+json: 
              schema: 
                type: object        